/* sane - Scanner Access Now Easy.
	Copyright (C) 2005 Mustek.
	Originally maintained by Mustek
	Author: Roy 2005.09

	This file is part of the SANE package.

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License as
	published by the Free Software Foundation; either version 2 of the
	License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston,
	MA 02111-1307, USA.

	As a special exception, the authors of SANE give permission for
	additional uses of the libraries contained in this release of SANE.

	The exception is that, if you link a SANE library with other files
	to produce an executable, this does not by itself cause the
	resulting executable to be covered by the GNU General Public
	License.  Your use of that executable is in no way restricted on
	account of linking the SANE library code into it.

	This exception does not, however, invalidate any other reasons why
	the executable file might be covered by the GNU General Public
	License.

	If you submit changes to SANE to the maintainers to be included in
	a subsequent release, you agree by submitting the changes that
	those changes may be distributed with this exception intact.

	If you write modifications of your own for SANE, it is your choice
	whether to permit this exception to apply to your modifications.
	If you do not wish that, delete this exception notice.

	This file provides a generic USB interface.  */

#ifndef _ASIC_
#define _ASIC_
#include "typedef.h"
#include "debug.h"
#include "public.h"

STATUS Asic_Open(PAsic chip, LPSTR pDeviceName);

STATUS Asic_Close(PAsic chip);

STATUS Asic_Release(PAsic chip);

STATUS Asic_Initialize(PAsic chip);

STATUS Asic_SetWindow(PAsic chip, BYTE bScanBits, 
				 WORD wXResolution, WORD wYResolution, 
				 WORD wX, WORD wY, WORD wWidth, WORD wLength);

STATUS Asic_TurnLamp(PAsic chip, BOOL isLampOn);

STATUS Asic_TurnTA(PAsic chip, BOOL isTAOn);

STATUS Asic_TurnLampEngineTA(PAsic chip, BOOL isLampOn); 

STATUS Asic_Reset(PAsic chip);

STATUS Asic_SetSource(PAsic chip, LIGHTSOURCE lsLightSource);

STATUS Asic_ScanStart(PAsic chip);

STATUS Asic_ScanStop(PAsic chip);

STATUS Asic_ReadImage(PAsic chip, LPBYTE pBuffer, 
										WORD LinesCount);

STATUS Asic_ReadNoUseImage(PAsic chip, WORD wXferBytes);

STATUS Asic_CheckFunctionKey(PAsic chip,LPBYTE key);

STATUS Asic_IsTAConnected(PAsic chip,PBOOL hasTA);

STATUS Asic_DownloadGammaTable(PAsic chip, LPVOID lpBuffer);

STATUS Asic_ReadCalibrationData(PAsic chip, LPVOID pBuffer, 
								DWORD dwXferBytes,BYTE bScanBits);
STATUS Asic_CalculateMaxMin(PAsic chip, LPBYTE pBuffer,LPWORD lpMaxValue,
							LPWORD lpMinValue,WORD wResolution);


STATUS Asic_TACalculateMaxMin(PAsic chip, LPBYTE pBuffer,LPWORD lpMaxValue,
						 LPWORD lpMinValue,WORD wResolution);


STATUS Asic_SetADConverter(PAsic chip);

STATUS Asic_SetMotorType(PAsic chip, 
						BOOL isMotorMove,BOOL isUniformSpeed);

STATUS Asic_MotorMove(PAsic chip, BOOL isForward,DWORD dwTotalSteps);

STATUS Asic_CarriageHome(PAsic chip, BOOL isTA);

STATUS Asic_SetShadingTable(PAsic chip, LPWORD lpWhiteShading, 
								LPWORD lpDarkShading, 
								WORD wXResolution, WORD wWidth, 
								WORD wX);

STATUS Asic_SetSoftwareShadingTable(PAsic chip, LPWORD lpWhiteShading, LPWORD lpDarkShading, WORD wXResolution, WORD wWidth, WORD wX);
STATUS Asic_DoSoftwareShadingRGB24Bit(PAsic chip, LPBYTE lpImageHead, WORD wWidth, WORD wStartLines, WORD wNumberOfLines);
STATUS Asic_DoSoftwareShadingGray8Bit(PAsic chip, LPBYTE lpImageHead, WORD wWidth, WORD wStartLines, WORD wNumberOfLines);
STATUS Asic_DoSoftwareShadingRGB48Bit(PAsic chip, LPBYTE lpImageHead, WORD wWidth, WORD wStartLines, WORD wNumberOfLines);
STATUS Asic_DoSoftwareShadingGray16Bit(PAsic chip, LPBYTE lpImageHead, WORD wWidth, WORD wStartLines, WORD wNumberOfLines);

STATUS Asic_WaitCarriageHome(PAsic chip, BOOL isTA);

STATUS Asic_IsTAHomePosition(PAsic chip, PBOOL isTAHome);

STATUS Asic_WaitUnitReady(PAsic chip);

STATUS Asic_SetCalibrate(PAsic chip,BYTE bScanBits, WORD wXResolution, 
						 WORD wYResolution, WORD wX, WORD wY, 
						 WORD wWidth, WORD wLength, BOOL isShading);

#endif /* End of file asic.h */
